<?php
	require_once('../../../phplibs/castiron.inc.php');
	require_once(CI_PATH_LIBS.'/session.inc.php');
	require_once(CI_PATH_LIBS.'/forms.inc.php');
	require_once(CI_PATH_LIBS.'/users.inc.php');

	CI_AUTH::require_auth('user', array('reply' => 'html', 'user' => $_REQUEST['id']));
	$login_info=CI_AUTH::get_login_info();

	$hidden_fields=array(
		'task'	=> 'save'
	);

	$roles=array(
		'user'			=> ci_lbl('users.users.info.role.user'),
		'groupadmin'	=> ci_lbl('users.users.info.role.groupadmin'),
		'admin'			=> ci_lbl('users.users.info.role.admin')
	);

	$fields=array(
		'base'	=> array(
			'fields'	=> array(
				'id'					=> array('type' => 'text', 'disabled' => $_REQUEST['id']),
				'ud_castiron_password'	=> array('type' => 'password'),
				'group'					=> array('type' => 'usergroup'),
				'ud_castiron_role'		=> array('type' => 'select', 'options' => $roles, 'disabled' => ($login_info['ud_castiron_role'] != 'admin')),
				'desc'					=> array('type' => 'text'),
				'ud_castiron_email'		=> array('type' => 'email'),
				'enabled'				=> array('type' => 'yesno')
			)
		),
		'advanced'	=> array(
			'fields'	=> array(
				'user'					=> array('type' => 'text'),
				'password'				=> array('type' => 'text'),
				'ud_castiron_webaccess'	=> array('type' => 'yesno')
			)
		)
	);

	$manager=new CI_USERS();
	$info=$manager->get_info($_REQUEST['id']);

	unset($info['ud_castiron_password']);

	$form=new CI_FORMS('form');
	$form->set_values($info);
	$form->set_action('actions/users.php');
	$form->set_fields($fields);
	$form->set_hidden_fields($hidden_fields);
	$form->set_tabs_label_prefix('users.users.info.tab-');
	$form->set_fields_label_prefix('users.users.info.fld-');

	$form->buttons->add_stock_button('back');
	$form->buttons->add_stock_button('reset');
	if ($_REQUEST['id']) $form->buttons->add_stock_button('delete');
	$form->buttons->add_stock_button('save');
?>
<script type="text/javascript">
	function on_modal_results(id, res)
	{
		if ((id=="delete") && (res==true))
		{
			$('form').task.value="delete";
			$('form').do_submit();
			ci_load_page('users/users/index.php');
		}
	}
	
	function on_button_event(id, task)
	{
		switch (task)
		{
			case 'back':	ci_load_page('users/users/index.php'); break;
			case 'reset':	$('form').reset(); break;
			case 'save':	$('form').do_submit(); break;
			case 'delete':	ci_modal_confirm("delete", "<?php echo ci_lbl('users.users.info.confirm-delete') ?>", "on_modal_results"); break;
		}
		ci_hide_error_block('form_error');
	}

	function on_form_event(id, task)
	{
	}
</script>

<?php if ($_REQUEST['id']) { ?>
<div class="title"><?php echo ci_lbl("users.users.info.title", array('name' => $info['id'])) ?></div>
<?php } else { ?>
<div class="title"><?php echo ci_lbl("users.users.info.title-new") ?></div>
<?php } ?>

<div class="help"><?php echo ci_hlp("users.users.info") ?></div>

<?php echo $form->get() ?>
