<?php
	class CI_FIELDS
	{
		function get($name, $info)
		{
			$name2=$name;
			if ($info['disabled'])
			{
				$info['extra']['disabled']="true";
				$name.="__disabled";
			}
			
			switch ($info['type'])
			{
				case 'yesno':
					$out=CI_FIELDS::get_yesno($name, $info);
					break;

				case 'label':
					$out=CI_FIELDS::get_label($name, $info);
					break;
					 
				case 'password':
					$out=CI_FIELDS::get_password($name, $info);
					break;
					 
				case 'group':
					$out=CI_FIELDS::get_group($name, $info);
					break;

				case 'date':
					$out=CI_FIELDS::get_date($name, $info);
					break;
					 
				case 'usergroup':
					$out=CI_FIELDS::get_usergroup($name, $info);
					break;

				case 'media':
					$out=CI_FIELDS::get_media($name, $info);
					break;
					 
				case 'select':
					$out=CI_FIELDS::get_select($name, $info);
					break;
					 
				case 'textarea':
					$out=CI_FIELDS::get_textarea($name, $info);
					break;
					 
				case 'file':
					$out=CI_FIELDS::get_file($name, $info);
					break; 
					
				default:
					$out=CI_FIELDS::get_text($name, $info);
					break; 
			}

			if ($info['extra']['disabled'] == "true")
				$out.='<input type="hidden" name="'.$name2.'" value="'.htmlspecialchars($info['value']).'" />';

			if ($info['note'])
				$out.='<span class="notes">'.$info['note'].'</span>';

			return $out;
		}

		function extra2string($extra)
		{
			if (!sizeof($extra)) return "";
			$out=array();

			foreach ($extra as $k => $v) array_push($out, "$k=\"".htmlspecialchars($v)."\"");
			return join(' ', $out);
		}

		function get_text($name, $info)
		{
			if (!$info['extra']['size']) $info['extra']['size']=30;
			$extra=CI_FIELDS::extra2string($info['extra']);
			
			$out ='<input '.$extra.' name="'.$name.'" type="text" value="'.htmlspecialchars($info['value']).'" />';
			return $out;
		}

		function get_textarea($name, $info)
		{
			if (!$info['extra']['cols']) $info['extra']['cols']=60;
			if (!$info['extra']['rows']) $info['extra']['rows']=3;
			
			$extra=CI_FIELDS::extra2string($info['extra']);
			
			$out ='<textarea '.$extra.' name="'.$name.'">'.htmlspecialchars($info['value']).'</textarea>';
			return $out;
		}

		function get_password($name, $info)
		{
			if (!$info['extra']['size']) $info['extra']['size']=30;
			$extra=CI_FIELDS::extra2string($info['extra']);
			
			$out ='<input '.$extra.' name="'.$name.'" type="password" value="'.htmlspecialchars($info['value']).'" />';
			return $out;
		}

		function get_file($name, $info)
		{
			$extra=CI_FIELDS::extra2string($info['extra']);
			
			$out ='<input '.$extra.' name="'.$name.'" type="file" />';
			return $out;
		}

		function get_yesno($name, $info)
		{
			$extra=CI_FIELDS::extra2string($info['extra']);

			$out ='<select name="'.$name.'" '.$extra.'>';
			$out.='<option value="false">'.ci_lbl('common.no').'</option>';
			$out.='<option value="true" '.($info['value'] == 'true' ? 'selected="true"' : '').'>'.ci_lbl('common.yes').'</option>';
			$out.='</select>';

			return $out;
		}

		function get_usergroup($name, $info)
		{
			require_once(CI_PATH_LIBS.'/groups.inc.php');
			$extra=CI_FIELDS::extra2string($info['extra']);

			$manager=new CI_GROUPS();
			$items=$manager->get_list();

			$out ='<select name="'.$name.'" '.$extra.'>';
			foreach ($items as $item)
				$out.='<option value="'.$item['id'].'">'.htmlspecialchars($item['desc']).'</option>';

			$out.='</select>';

			return $out;
		}

		function get_label($name, $info)
		{
			return $info['text'];
		}

		function get_group($name, $info)
		{
			global $CI_URI_BASE;

			$items=preg_split('/\s*,\s*/', $info['value']);

			$click="javascript:ci_fields_group_select('$name', '".$info['url']."')";
			
			$out ='<input id="'.$name.'" type="hidden" name="'.$name.'" value="'.htmlspecialchars($info['value']).'" />';
			$out.='<img src="'.$CI_URI_BASE.'/icons/fields/group.png" alt="" style="float: left; margin-right: 5px;" /> <span style="height: 16px; line-height: 16px"><a href="'.$click.'">'.ci_lbl('common.select-items').'</a></span>';
			$out.='<a id="'.$name.'_view" href="'.$click.'" class="fields_group" style="clear: both;">';

			if (!$info['value'])
				$out.='<i>'.ci_lbl('common.none-selected').'</i>';
			else
				$out.=join(', ', $items);

			$out.='</a>';

			return $out;
		}

		function get_select($name, $info)
		{
			$extra=CI_FIELDS::extra2string($info['extra']);

			$items=$info['options'];

			$out ='<select name="'.$name.'" '.$extra.'>';
			if ($info['null']) $out.='<option value=""></option>';
			
			foreach ($items as $k => $v)
			{
				if (is_array($v))
					$out.='<option value="'.$k.'" '.CI_FIELDS::extra2string($v).' '.($k == $info['value'] ? ' selected="true"' : '').'>'.htmlspecialchars($v['value']).'</option>';
				else
					$out.='<option value="'.$k.'" '.($k == $info['value'] ? ' selected="true"' : '').'>'.htmlspecialchars($v).'</option>';
			}

			$out.='</select>';

			return $out;
		}

		function get_date($name, $info)
		{
			$info['extra']['id']=uniqid('date_');
			
			$out =CI_FIELDS::get_text($name, $info);
			$out.='<script type="text/javascript">';
			$out.='myCal1 = new Calendar({ '.$info['extra']['id'].': "Y/m/d" }, { months:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"], navigation: 2, direction: 0, tweak: { x: 6, y: 0 }});';
			$out.='</script>';

			return $out;
		}

		function get_media($name, $info)
		{
			require_once(CI_PATH_LIBS.'/settings_media.inc.php');

			$manager=new CI_SETTINGS_MEDIA();
			$items=$manager->get_list();

			$info['options']=array();

			foreach ($items as $item)
			{
				$mymodes=array();
				switch($item['mode'])
				{
					case 'email':	$mymodes=array('message', 'file'); break;
					case 'ftp':		$mymodes=array('file'); break;
					case 'scp':		$mymodes=array('file'); break;
					case 'sms':		$mymodes=array('message'); break;
					case 'chat':	$mymodes=array('message'); break;
				}

				if ($info['modes'] && !sizeof(array_intersect($info['modes'], $mymodes))) continue;
				
				$info['options'][$item['id']]=array(
					'value' => htmlspecialchars($item['desc']).' ['.$item['destination'].']',
					'title'	=> $item['mode']
				);
			}

			return CI_FIELDS::get_select($name, $info);
		}
	}
?>