<?php
	require_once(CI_PATH_LIBS.'/config.inc.php');
	
	class CI_FILTERS_IN extends CI_CONFIG
	{
		function get_config_file()
		{
			return IGX_PATH_BASE.'/config/filters/filters-in.xml';
		}

		function get_rmap($info)
		{
			return array(
				'id'		=> $info['id'],
				'desc'		=> $info['desc'],
				'policy'	=> $info['policy'],
				'enabled'	=> $info['enabled'],
				'to'	=> array(
					'item'	=> array('/.+/')
				),
				'from'	=> array(
					'item'	=> split(',', $info['from_skype'])
				)
			);
		}

		function get_map($info)
		{
			$info['to']['item']=@ci_normalize_xml_array($info['to']['item']);
			$info['from']['item']=@ci_normalize_xml_array($info['from']['item']);
			
			return array(
				'id'			=> $info['id'],
				'desc'			=> $info['desc'],
				'policy'		=> $info['policy'],
				'enabled'		=> $info['enabled'],
				'to_skype'		=> join(',', $info['to']['item']),
				'from_skype'	=> join(',', $info['from']['item'])
			);
		}
		
		function task_save($info)
		{
			if (!$info['id']) $info['id']=md5(uniqid(''));

			$fields=$this->get_rmap($info);
			
			/* Retrieve item position */
			$n=$this->get_n($info['id']);

			/* Save */
			$list =& $this->get_raw_list();
			$list[$n]=$fields;

			$this->save_raw_config($list);
			
			return ci_response_ok();
		}
	}

	class CI_FILTERS_OUT extends CI_CONFIG
	{
		function get_config_file()
		{
			return IGX_PATH_BASE.'/config/filters/filters-out.xml';
		}

		function get_rmap($info)
		{
			return array(
				'id'		=> $info['id'],
				'desc'		=> $info['desc'],
				'enabled'	=> $info['enabled'],
				'policy'	=> $info['policy'],
				'apply-to'	=> $info['apply_to'],
				'to'	=> array(
					'item'	=> split(',', $info['to_skype'])
				),
				'from'	=> array(
					'item'	=> array('/.+/')
				)
			);
		}

		function get_map($info)
		{
			$info['to']['item']=@ci_normalize_xml_array($info['to']['item']);
			$info['from']['item']=@ci_normalize_xml_array($info['from']['item']);
			
			return array(
				'id'			=> $info['id'],
				'desc'			=> $info['desc'],
				'enabled'		=> $info['enabled'],
				'policy'		=> $info['policy'],
				'apply_to'		=> $info['apply-to'],
				'to_skype'		=> join(',', $info['to']['item']),
				'from_channel'	=> join(',', $info['from']['item'])
			);
		}
		
		function task_save($info)
		{
			if (!$info['id']) $info['id']=md5(uniqid(''));

			$fields=$this->get_rmap($info);
			
			/* Retrieve item position */
			$n=$this->get_n($info['id']);

			/* Save */
			$list =& $this->get_raw_list();
			$list[$n]=$fields;

			$this->save_raw_config($list);
			
			return ci_response_ok();
		}
	}
?>