#!/usr/bin/env python

# Copyright and license: Please refer to LICENSE.TXT

import sys
import os
import time
import os.path

_selfpath=(os.path.dirname(os.path.realpath(__file__)).split('/'))[:-1]
_selfpath.append('pylibs')
_libspath='/'.join(_selfpath)
sys.path.append(_libspath)

from s2p import *

sys.path.append(CORE_PATH_SDK+'/python')

from s2p_base import *

s2ps=S2P_SKYPE()
res=s2ps.command("", "list-status", {})

status=res['args']
secs_count=0
sess_count=0
secs_max=0
sess_max=''

print "%-30s: %4s secs %30s" % ("Account", "Secs", "Partner")
print "----------------------------------------------------------------------------------------"

for k in status.keys():
	try:
		items=re.split(r',', status[k])
		status2={}
		for item in items:
			kv=re.split(r':', item)
			status2[kv[0]]=kv[1]

		secs=int(time.time()-float(status2['time']))
		secs_count=secs_count+secs
		sess_count=sess_count+1

		if secs > secs_max:
			secs_max=secs
			sess_max=k

		print "%-35s: %4d secs %35s [%s]" % (k, secs, status2['partner'], status2['direction'])

	except:
		print "%-35s: %4s" % (k, '-')

print "----------------------------------------------------------------------------------------"
try:
	print "Average duration  : %4d" % int(secs_count/sess_count)
	print "Active calls      : %4d" % sess_count
	print "Longest call      : %4d [%s]" % (secs_max, sess_max)
except:
	1

print

s2ps.stop()
sys.exit(0)
